   
;===================================================================
;                   RANDOM.ASM
;      r a n d o m   n u m b e r   g e n e r a t o r
;
; GENERATES PSEUDO-RANDOM INTEGERS IN THE RANGE LOWER TO UPPER
; INPUT:  TWO STACK PARAMETERS - LOWER AND UPPER ENDS OF RANGE
; OUTPUT: AX-REG CONTAINS RANDOM INTEGER
; CALLING SEQUENCE:     PUSH    <LOWER END OF RANGE>
;                       PUSH    <UPPER END OF RANGE>
;                       CALL    RANDOM
;===================================================================
           .MODEL  SMALL, BASIC
   .586
           .STACK 256
;===================================================================
; D A T A   S E G M E N T   D E F I N I T I O N
           .DATA
SEED       DW      ?                   ;SEED FOR RANDOM NUMBER GEN.
MULTIPLIER DW      25173               ;MULTIPLIER AND
ADDEND     DW      13849               ;ADDEND FOR MIXED
                                       ;LINEAR CONGRUENTIAL METHOD
UPPER    DW      9999
LOWER      DW      0
PUBLIC SEED
;===================================================================
; C O D E   S E G M E N T   D E F I N I T I O N
           .CODE   
           ASSUME  DS:DGROUP



RESEED     PROC    NEAR PUBLIC
           MOV     AX,DGROUP    ;SET DS-REGISTER TO POINT
           MOV     DS,AX               ;TO LOCAL DATA SEGMENT

                                    ;SAVE REGISTERS (USES LIST)
           PUSHF                    ;SAVE FLAGS
   CMP BL,0
   JNE NOTZERO
   PUSH LOWER
   PUSH UPPER
   CALL RANDOM
   MOV  SEED, AX
NOTZERO:
   MOV SEED,555H
           POPF                        ;RESTORE FLAGS
                                       ;RESTORE REGISTERS (ASSEMBLER
                                       ;GENERATES INSTRUCTIONS TO
                                       ;RESTORE REGISTERS - USES)
           RET                         ;RETURN
RESEED     ENDP                     



RANDOM       PROC    NEAR PUBLIC USES CX DX DS
                                       ;FUNCTION RANDOM(LOWER,UPPER)
                                       ;SAVE REGISTERS (USES LIST)
           PUSHF                       ;SAVE FLAGS

;

           MOV     AH,0                ;     SEED = LOWER HALF OF
           INT     1AH                 ;            TIME OF DAY CLOCK
           MOV     SEED,DX

           MOV     AX,SEED             ;X = SEED * MULTIPLIER mod
           MUL     MULTIPLIER          ;                       65536
           ADD     AX,ADDEND           ;SEED = (X + ADDEND) mod 65536
           MOV     SEED,AX
           MOV     CX,UPPER            ;RANGE = UPPER - LOWER + 1
           SUB     CX,LOWER
           INC     CX
           MUL     CX                  ;RANDOM = (SEED*RANGE)/65536
           ADD     DX,LOWER            ;                    + LOWER
           MOV     AX,DX
           POPF                        ;RESTORE FLAGS
                                       ;RESTORE REGISTERS (ASSEMBLER
                                       ;   GENERATES INSTRUCTIONS TO
                                       ;   RESTORE REGISTERS - USES)
           RET     4                        ;RETURN (RANDOM)
RANDOM       ENDP                     ;END RAND
           END   RESEED    